﻿using System.Collections.Generic;
using System.ComponentModel.DataAnnotations;

namespace ThumpThumpBus.Models.ViewModels
{
    public class ReportIncidentViewModel
    {
        [DataType(DataType.MultilineText)]
        [DisplayFormat(ConvertEmptyStringToNull=false)]
        public string Reason { get; set; }

        public IEnumerable<PersonViewModel> People { get; set; }
        public int SelectedAssailantId { get; set; }
        public int SelectedVictimId { get; set; }
        public bool IsSubmitted { get; set; }
        
        public ReportIncidentViewModel() : this(null) { }

        public ReportIncidentViewModel(IEnumerable<PersonViewModel> people)
        {
            People = people;
            Reason = string.Empty;
            SelectedAssailantId = 0;
            SelectedVictimId = 0;
        }
    }
}